<template>
  <div class="app-container">
    <el-form v-show="showSearch" ref="queryRef" :model="queryParams" :inline="true" label-width="68px">
      <el-form-item label="登录账号" prop="userName">
        <el-input v-model="queryParams.userName" clearable placeholder="请输入登录账号" @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="登录地址" prop="ipaddr">
        <el-input v-model="queryParams.ipaddr" clearable placeholder="请输入登录地址" @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="状态" prop="status">
        <el-select v-model="queryParams.status" clearable placeholder="登录状态">
          <el-option
            v-for="dict in sys_success_fail"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="登录时间" style="width: 308px">
        <el-date-picker
          v-model="dateRange"
          value-format="YYYY-MM-DD HH:mm:ss"
          type="daterange"
          range-separator="-"
          start-placeholder="开始日期"
          end-placeholder="结束日期"
          :default-time="[new Date(2000, 1, 1, 0, 0, 0), new Date(2000, 1, 1, 23, 59, 59)]"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          v-has-permi="['system:loginlog:remove']"
          type="danger"
          icon="Delete"
          plain
          :disabled="multiple"
          @click="handleDelete"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          v-has-permi="['system:loginlog:remove']"
          type="danger"
          icon="Delete"
          plain
          @click="handleClean"
        >清空</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          v-has-permi="['system:loginlog:unlock']"
          type="primary"
          icon="Unlock"
          plain
          :disabled="single"
          @click="handleUnlock"
        >解锁</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          v-has-permi="['system:loginlog:export']"
          type="warning"
          icon="Download"
          plain
          @click="handleExport"
        >导出</el-button>
      </el-col>
      <right-toolbar v-model:show-search="showSearch" @query-table="getList" />
    </el-row>

    <el-table ref="logininforRef" v-loading="loading" :data="logininforList" :default-sort="defaultSort" @selection-change="handleSelectionChange" @sort-change="handleSortChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="编号" align="center" prop="loginId" />
      <el-table-column label="登录账号" align="center" prop="userName" :show-overflow-tooltip="true" />
      <el-table-column label="地址" align="center" prop="ipaddr" :show-overflow-tooltip="true" />
      <el-table-column label="设备类型" align="center" prop="deviceType">
        <template #default="scope">
          <dict-tag :options="login_device_type" :value="scope.row.deviceType" />
        </template>
      </el-table-column>
      <el-table-column label="登录状态" align="center" prop="status">
        <template #default="scope">
          <dict-tag :options="sys_success_fail" :value="scope.row.status" />
        </template>
      </el-table-column>
      <el-table-column label="描述" align="center" prop="remark" :show-overflow-tooltip="true" />
      <el-table-column label="登录时间" align="center" prop="createTime" width="180">
        <template #default="scope">
          <span>{{ $parseTime(scope.row.createTime) }}</span>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total > 0"
      v-model:page="queryParams.pageNumber"
      v-model:limit="queryParams.pageSize"
      :total="total"
      @pagination="getList"
    />
  </div>
</template>

<script name="LoginLog" setup>
import { listLoginLog, unlockLoginLog, delLoginLog, cleanLoginLog } from '@/api/system/loginlog'

const { proxy } = getCurrentInstance()
const { login_device_type, sys_success_fail } = proxy.$useDict('login_device_type', 'sys_success_fail')

const logininforList = ref([])
const loading = ref(true)
const showSearch = ref(true)
const ids = ref([])
const single = ref(true)
const multiple = ref(true)
const selectName = ref('')
const total = ref(0)
const dateRange = ref([])
const defaultSort = ref({ prop: 'createTime', order: 'descending' })

// 查询参数
const queryParams = ref({
  pageNumber: 1,
  pageSize: 10,
  ipaddr: undefined,
  userName: undefined,
  status: undefined,
  orderByColumn: undefined,
  isAsc: undefined,
  startTime: undefined,
  endTime: undefined
})

/** 查询登录日志列表 */
function getList() {
  loading.value = true
  listLoginLog(proxy.$addDateRange(queryParams.value, dateRange.value)).then(res => {
    logininforList.value = res.list
    total.value = Number(res.total)
    loading.value = false
  })
}
/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNumber = 1
  getList()
}
/** 重置按钮操作 */
function resetQuery() {
  dateRange.value = []
  proxy.$resetForm('queryRef')
  queryParams.value.pageNumber = 1
  proxy.$refs['logininforRef'].sort(defaultSort.value.prop, defaultSort.value.order)
}
/** 多选框选中数据 */
function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.loginId)
  multiple.value = !selection.length
  single.value = selection.length !== 1
  selectName.value = selection.map(item => item.userName)
}
/** 排序触发事件 */
function handleSortChange(column, prop, order) {
  queryParams.value.orderByColumn = column.prop
  queryParams.value.isAsc = column.order
  getList()
}
/** 删除按钮操作 */
function handleDelete(row) {
  const loginIds = row.loginId || ids.value
  proxy.$modal.confirm('是否确认删除编号为"' + loginIds + '"的数据项?').then(function() {
    return delLoginLog(loginIds)
  }).then(() => {
    getList()
    proxy.$modal.msgSuccess('删除成功')
  }).catch(() => {})
}
/** 清空按钮操作 */
function handleClean() {
  proxy.$modal.confirm('是否确认清空所有登录日志数据项?').then(function() {
    return cleanLoginLog()
  }).then(() => {
    getList()
    proxy.$modal.msgSuccess('清空成功')
  }).catch(() => {})
}
/** 解锁按钮操作 */
function handleUnlock() {
  const username = selectName.value
  proxy.$modal.confirm('是否确认解锁用户"' + username + '"数据项?').then(function() {
    return unlockLoginLog(username)
  }).then(() => {
    proxy.$modal.msgSuccess('用户' + username + '解锁成功')
  }).catch(() => {})
}
/** 导出按钮操作 */
function handleExport() {
  proxy.$download('system/loginlog/export', {
    ...queryParams.value
  }, `loginlog_${new Date().getTime()}.xls`)
}

getList()
</script>
